<%
'******************************************************************
' Function : Currency Functions
' Product  : Shopping Tree Store Frontend
' Version  : 3.2
' Modified : January 2005
' Copyright: Copyright (C) 2004 Shopping Tree.Com 
'            See "license.txt" for this product for details regarding 
'            licensing, usage, disclaimers, distribution and general 
'            copyright requirements. If you don't have a copy of this 
'            file, you may request one at webmaster@ShoppingTree.com
'*******************************************************************		
'	Date						Description
' 01/02/2006	The value being passed into Exchange was changed from byref (default) to byval. 
'
'*******************************************************************				
dim selectedCurrency
dim rsCurr
dim currencyCode

currencyCode = request.cookies("CurrencyCode")
if len(currencyCode) = 0 or IsNull(currencyCode) then 
	response.cookies("CurrencyCode") = currencyDefault
	response.cookies("CurrencyCode").expires = dateAdd("d",30,now())
	response.cookies("CurrencyCode").path = "/"
	currencyCode = currencyDefault
	pCurrencySign = moneySymbol(currencyCode)
	session("Currency") = currencyCode
else 
	pCurrencySign = moneySymbol(request.cookies("CurrencyCode"))
	session("Currency") = currencyCode
end if

selectedCurrency = request.Form("selectedCurrency")
if len(selectedCurrency) = 0 then
	selectedCurrency = request.QueryString("selectedCurrency")
	if len(selectedCurrency) <> 0 then 
		rateChange(selectedCurrency)
	end if
else
	rateChange(selectedCurrency)
end if	

'Get a new rate if changed
'
'*******************************************************************************
'Get the rate selected
'*****************************************************************************
function rateChange(selectedCurrency)
Dim mySQL
' current working currency = the same currency, should never happen, exit function
if request.Cookies("CurrencyCode") = selectedCurrency then
 exit function				
end if
response.Cookies("CurrencyCode") = selectedCurrency
response.Cookies("CurrencyCode").expires = dateAdd("d",30,now())
pCurrencySign = moneySymbol(selectedCurrency)

end function

'**********************************************************************
'See if we need to refresh the rates and if so get the file from FRB
'**********************************************************************
sub getSpotRates(curYear,curMonth,curDay)

dim oXMLServer
dim sReply
dim httpResponseText
dim oXMLDoc
dim oCurrency
dim oKey
dim oOBS
dim sCountry
dim sValue
dim sUSD
dim oNode
dim sUnit

'See if spot rates are enabled
if pFRBNYEnabled <> "-1" then exit sub

'get the file from ny.frb.org
  set oXMLServer = server.CreateObject(MSXMLprogID)
  if IsObject(oXMLServer) then
	  oXMLServer.open "GET", "http://www.ny.frb.org/markets/fxrates/FXtoXML.cfm?FEXdate=" & curYear & "%2D" & curMonth & "%2D" & curDay & "%2000%3A00%3A00&FEXtime=1200", False
	  on error resume next
	  err.number = 0
	  oXMLServer.send sReply
  else
	    response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrUnableToCreateObject","Unable to creat object ") & MSXMLprogID)
  end if  
  if err.number > 0 or oXMLServer.status <> 200 then
  	'response.flush
  	'response.write "-------> " & err.number & " " & oXMLServer.status & " <-----------<br>"
  	exit sub
  end if
  set oXMLDoc = server.CreateObject(XMLDOMprogID)
  if IsObject(oXMLDOC) then
	  ' Insert the new rates in to the Currency table
	  oXMLDoc.validateOnParse = False 'Fails on XSD for namespace
	  oXMLDoc.loadXML oXMLServer.responseText
	  If oXMLDoc.parseError.errorCode <> 0 Then
	    response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(oXMLDoc.parseError.reason & "<br>" & oXMLDoc.parseError.srcText)
	  End If
	  
	  Set oXMLServer = Nothing
	  Set oCurrency = oXMLDoc.documentElement.childNodes(1).childNodes
	  if oCurrency.length <> 0 then 
		  For Each oNode In oCurrency
		    sUnit = oNode.Attributes.getNamedItem("UNIT").Text
		    Set oKey = oNode.childNodes(0).childNodes(1)
		    sCountry = oKey.Text
		    Set oOBS = oNode.childNodes(1).childNodes(1)
		    sValue = oOBS.Text
		    If sUnit = "USD" Then
		      sUnit = sCountry
		      sCountry = "USD"
		      sValue = round(1 / sValue,4) & ""
		    End If
		      mySQL = "INSERT INTO [CurrencyRates] ( code, rate, spotdate) " _
		      		& "VALUES ('" & sUnit & "'," & sValue & ",'" & curYear & curMonth & curDay & "');"
		      set rsCurr = openRSexecute(mySQL)
		      set rsCurr = Nothing
		  Next
		  mySQL = "INSERT INTO [CurrencyRates] ( code, rate, spotdate) " _
		      	& "VALUES ('USD'," & 1.0000 & ",'" & curYear & curMonth & curDay & "');"
		  set rsCurr = openRSexecute(mySQL)
		  set rsCurr = Nothing
		  Set oXMLDoc = Nothing
	  end if
	Else
	    response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrUnableToCreateObject","Unable to creat object ") & XMLDOMprogID)
	end if
	
end sub

'********************************************************************************
'get the exchange rate
'*******************************************************************************
function getRate(code)
	dim rsRate
	getRate = 1.0000
	mySQL = "SELECT rate " _
		  & "FROM CurrencyRates " _
		  & "WHERE SpotDate = (SELECT MAX(spotdate) FROM CurrencyRates) and Code = '" & code & "';"
	set rsRate = openRSexecute(mySQL)
	if not rsRate.eof then
		getRate = round(rsRate("rate"),4)
	else
		'response.redirect  "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrNoCurrencyRate","No currency rate for code: ") & code & " for you")
	end if
	closeRS(rsRate)
	set rsRate = Nothing
end function

'======================================================
' Supply HTML for currency selection
'======================================================
sub currencySupport()
	dim curYear
	dim curMonth
	dim curDay
	dim curDOW
	dim curDate
	dim sCode
	dim sCountry
	dim selectedCurrency
	dim protocol
	
	protocol = "http://"
	
	if lCase(request.servervariables("HTTPS")) = "on" then protocol = "https://"
	selectedCurrency = request.cookies("CurrencyCode")
	
	curDate = date
	
	'Check the time offset
	if CurrencyOffset <> 0 then
	  curDate = dateAdd("h",CurrencyOffset,curDate)
	end if
	 
	curDOW = datepart("w",curDate)
	' if on a weekend back up to Friday of previous week
	if curDOW = vbSunday then 'Sunday subtract 2 days
		curDate = dateAdd("d",-2,curDate)
	elseif curDOW = vbSaturday then 
		curDate = dateAdd("d",-1,curDate)
	end if	
	
	curYear = year(curDate) & ""
	curMonth = month(curDate) & ""
	curDay = day(curDate) & ""
	
	
	if len(curMonth) = 1 then curMonth = "0" & curMonth
	if len(curDay) = 1 then curDay = "0" & curDay
	
	'Get the currencies supported
		mySQL = "SELECT Currency.Code, CountryName " _
			  & "FROM [Currency] INNER JOIN CurrencyRates ON Currency.Code = CurrencyRates.Code " _
			  & "WHERE (Currency.Active = -1) and CurrencyRates.SpotDate = '" & curYear & curMonth & curDay & "' " _
			  & "ORDER BY CountryName;"
	set rsCurr = openRSexecute(mySQL)
	if rsCurr.eof then
		closeRS(rsCurr)
		call getSpotRates(curYear,curMonth,curDay) 
		mySQL = "SELECT Currency.Code, CountryName " _
			  & "FROM [Currency] INNER JOIN CurrencyRates ON Currency.Code = CurrencyRates.Code " _
			  & "WHERE (((Currency.Active)=-1) and CurrencyRates.SpotDate = (SELECT MAX(spotdate) FROM CurrencyRates)) " _
			  & "ORDER BY CountryName;"
		set rsCurr = openRSexecute(mySQL)
	end if
%>
	<form method="POST" action="<%=protocol%><%=request.ServerVariables("HTTP_HOST")%><%=request.ServerVariables("URL")%>?<%=request.ServerVariables("QUERY_STRING")%>" name="CurrencyChange">
	<b><%=LangText("GenDisplayCurrency","Currency")%></b>
	<br><select onchange="this.form.submit();" name="selectedCurrency">
<%
	do while not rsCurr.eof
		sCode = rsCurr("Code")
		sCountry = rsCurr("CountryName")
%>
		<option value="<%=sCode%>" <%=checkMatch(selectedCurrency,sCode)%> ><%=sCountry & " (" & sCode & ")"%></option>
<%
		rsCurr.movenext
	loop
	closeRS(rsCurr)
	set rsCurr = nothing
%>
	</select>
<%
	mySQL = "SELECT MAX(spotdate) as maxspotdate FROM CurrencyRates"
	set rsCurr = openRSexecute(mySQL)
	if not rsCurr.eof then
		'See if spot rates are enabled
		if pFRBNYEnabled = "-1" then 
%>
			<b><span class="Rate" style="font-size: 6pt">FRBNY rates as of <%=rsCurr("maxspotdate")%></span></b>
<%
		else
%>
			<b><span class="Rate" style="font-size: 6pt">Rates as of <%=rsCurr("maxspotdate")%></span></b>
<%
		
		end if
	end if
%>
	</form>
<%
end sub

'================================================================
' Exchange convert Store value to selected currency
'================================================================
function Exchange(ByVal amount)
dim selectedCurrency

' Conversion required?
selectedCurrency = request.cookies("CurrencyCode")
if selectedCurrency = currencyDefault then
	Exchange = amount
	exit function
end if
if currencyDefault <> "USD" then 'convert the amount to USD
  if getRate(currencyDefault) > 1 then 
  	amount = amount / getRate(currencyDefault)
  else
	amount = amount * getRate(currencyDefault)
  end if
end if

'amount is now in USD. Now convert to selected currency
	Exchange = round(getRate(selectedCurrency) * amount,2)
end function

'===============================================================
' Get the symbol to be used with the displayed currency code
'===============================================================
function moneySymbol(code)
	moneySymbol = pCurrencySign
	session("LorR") = pCurrSymbolPlacement
	if pCurrencyEnabled = "0" then 	exit function
	mySQL = "SELECT symbol, LorR " _
		  & "FROM [Currency] " _
		  & "WHERE code = '" & code & "'"
	set rsCurr = openRSexecute(mySQL)
	if not rsCurr.eof then
		moneySymbol = rsCurr("symbol")
		session("LorR") = rsCurr("LorR")
	end if
	closeRS(rsCurr)
	set rsCurr = Nothing
end function
	
%>