<%@ Language=VBScript %>
<%
'*************************************************************************
' DO NOT MODIFY THIS SCRIPT IF YOU WANT UPDATES TO WORK!
' Function : Estimate Shipping Rates for an order
' Product  : Shopping Tree Store Frontend
' Version  : 3.3
' Modified : January 2005
' Copyright: Copyright (C) 2004 Shopping Tree.Com 
'            See "license.txt" for this product for details regarding 
'            licensing, usage, disclaimers, distribution and general 
'            copyright requirements. If you don't have a copy of this 
'            file, you may request one at webmaster@ShoppingTree.com
'*************************************************************************
'	Date						Description
' 01/21/06	Add FedEx logo support
' 04/14/06	Added address type support for UPS rates 
' 05/31/06	Correct shipping Array error
'************************************************************************
Option explicit
Response.Buffer = true
%>
<!--#include file="_INCconfig_.asp"-->
<!--#include file="_INCappDBConn_.asp"-->
<!--#include file="_INCappFunctions_.asp"-->
<!--#include file="_INCshipFunctions_.asp"-->
<!--#include file="_INClocations_.asp"-->
<%
'Work fields
dim f, item
dim formArray
dim locShipZone
dim validFormFields
dim validRatesFound
dim shipError

'Customer
dim shippingZip
dim shippingLocState
dim shippingLocCountry
dim shippingMunicipality
dim addrType

'Locations
dim locName

'Database
dim mySQL
dim conntemp
dim rstemp
dim rstemp2

'Session
dim idOrder
dim idCust

'*************************************************************************

'Open Database Connection
call openDb()

'Store Configuration
if loadConfig() = false then
	call errorDB(LangText("ErrConfig",""),"")
end if

'Get/Set Cart/Order Session
idOrder = sessionCart()

'Get/Set Customer Session
idCust  = sessionCust()

'Check if the session is still active
if isNull(idOrder) then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrCartEmpty",""))
end if

'Check if cart has any items
if cartQty(idOrder) = 0 then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrCartEmpty",""))
end if

'Get State and Country arrays
call getStateArray()
call getCountryArray()
call getMunicipalityArray()
if not isArray(countryArr) then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrCountry",""))
end if

'If the script called itself, do some checks and get rates
if Request.Form("formID") = "01" then

	'Retrieve values from the form
	shippingZip			= validHTML(request.form("shippingZip"))
	shippingLocState	= validHTML(request.form("shippingLocState"))
	shippingLocCountry	= validHTML(request.form("shippingLocCountry"))
	shippingMunicipality= validHTML(request.form("shippingMunicipality"))
	shippingaddrtype    = request.form("addrtype")
	addrType = shippingaddrtype
	
	'Check Form Fields
	if len(shippingZip) = 0 _
	or len(shippingLocCountry) = 0 _
	or not validLoc(shippingLocState,shippingLocCountry) then
	
		'Form Fields are not valid
		validFormFields = false
		validRatesFound = false
		
	else
	
		'Form Fields are valid
		validFormFields = true
		
		'Determine Shipping Zone

		locShipZone = getShipZone(shippingLocCountry,shippingLocState,shippingMunicipality,shippingZip)
		if locShipZone = null then
		
			'Invalid shipping zone
			validRatesFound = false

		else

			'Determine Totals to be used when calculating shipping rates
			call calcShipTotals(idOrder)

			'Free Shipping if no items were found that requires shipping.
			if totalShipItems = 0 then 
				shipArray(0,0) = 0.00
				shipArray(0,1) = LangText("GenNoShipCharge","")
				
			'Calculate shipping rates
			else

				'Initialize shipping error session variable
				session(storeID & "shipError") = ""

				'Calculate Store Rates
				call calcStoreRates(totalShipPrice,totalShipWeight,locShipZone)

				'Check for free shipping (A rate of zero)
				for f = 0 to ubound(shipArray) - 1
					if len(shipArray(f,1)) <> "" then
						exit for
					else
						if shipArray(f,0) = 0.00 then
							redim shipArray(100,2)
							shipArray(0,0) = 0.00
							shipArray(0,1) = LangText("GenNoShipCharge","")
							exit for
						end if
					end if
				next
				
				'Calculate Realtime Rates
				call calcOnlineRates(totalShipWeight,shippingLocCountry,shippingLocState,shippingZip)
				
				'Move error (if any) to local variable for later evaluation
				if session(storeID & "shipError") <> "" then
					shipError = session(storeID & "shipError")
				end if
				session(storeID & "shipError") = null
				
			end if

			'Execute Custom shipping rates user exit %>
			<!--#include file="../UserMods/_INCship_.asp"--> <%

			'Check shipping rate array
			validRatesFound = validShipArray()
			
			'For debug purposes, write shipping data as hidden HTML
			Response.Write vbCrlf & "<!-- P[" & totalShipPrice & "] W[" & totalShipWeight & "] I[" & totalShipItems & "] Z[" & locShipZone & "] -->" & vbCrlf
			
			'Store fields in a cookie
			Response.Cookies("shipEst") = shippingZip & "*|*" & shippingLocState & "*|*" & shippingLocCountry & "*|*" & shippingMunicipality
			Response.Cookies("shipEst").expires = Date() + 30
			
		end if
		
	end if
	
else

	'See if there's anything stored in the cookie and retrieve it
	for each item in Request.Cookies
		if item = "shipEst" then
			formArray			= Split(Request.Cookies(item),"*|*")
			shippingZip			= formArray(0)
			shippingLocState	= formArray(1)
			shippingLocCountry	= formArray(2)
			shippingMunicipality= formArray(3) 
			exit for
		end if
	next

end if

%>
<!--#include file="../UserMods/_INCtemplate_.asp"-->
<%

'Close Database Connection
call closedb()

'**********************************************************************
'Main Shopping Cart Display Area.
'**********************************************************************
sub cartMain()

	'If there were errors, show message (except first time page is shown)
	if  Request.Form("formID") = "01" and not (validFormFields and validRatesFound) then
%>
		<table border="0" cellpadding="0" cellspacing="0" width="350">
		<tr><td>
			<font color=red><i>
<%
			if not validFormFields then
				response.Write LangText("ErrInvForm","")
			else
				if shipError = "" then 
					response.write LangText("ErrNoShipRate","") 
				else 
					response.write shipError
				end if
				response.Write " (P" & totalShipPrice & " W" & totalShipWeight & " Z" & locShipZone & ")"
			end if
%> 
			</i></font><br><br>
		</td></tr>
		</table>
<%
	end if
%>

	<!-- Outer Table Cell -->
	<table border="0" cellpadding="0" cellspacing="0" width="80%"><tr><td>

	<!-- Inner Table -->
	<table border="0" cellspacing="0" cellpadding="2" width="100%">
		<form method="POST" name="shipEstForm" action="shipEst.asp">
		<TR>
			<TD colspan=2 valign=middle class="CPpageHead">
				<b><%=LangText("GenEstShip","")%></b>
			</TD>
		</TR>
		<TR>
			<TD colspan=2><img src="../../UserMods/misc_cleardot.gif" height=4 width=1></TD>
		</TR>
		<TR> 
			<TD nowrap><%=LangText("GenCountry","")%></TD>
			<TD><%listCountries "shippingLocCountry",shippingLocCountry%></TD>
		</TR>		
<%		if isArray(stateArr) then %>
			<TR> 
				<TD nowrap><%=LangText("GenState","")%></TD>
				<TD><%listStates "shippingLocState",shippingLocState,shippingLocCountry%></TD>
			</TR>
			<TR>
				<td nowrap ><%=LangText("GenMunicipality","Municipality")%></td>
				<td><input type="text" value="<%=shippingMunicipality%>" name="shippingMunicipality" size="30" maxlength="50"></td>
			</TR>
<%		else %>
			<input type=hidden name=shippingLocState value="">
<%		end if %>
		<TR> 
			<TD nowrap><%=LangText("GenZip","")%></TD>
			<TD><input type=text name=shippingZip size=10 maxlength="10" value="<%=shippingZip%>"></TD>
		</TR>
		<TR>
			<TD nowrap><%=LangText("GenAddrType","Address Type")%></td>
			<TD nowrap>
				<select name="AddrType" >
				<option value="R" <%=checkMatch(addrtype,"R")%> ><%=LangText("GenAddrTypeRes","Residential")%></option>
				<option value="B" <%=checkMatch(addrtype,"B")%> ><%=langText("GenAddrTypeBus","Business")%></option> 
				</select>
			</TD>
		</TR>
		<TR> 
			<TD colspan=2>&nbsp;</TD>
		</TR>
		<TR>
			<TD>
				<input type="hidden" name="formID" value="01">
				<input type="submit" name="ReturnCart" onclick="this.form.action = '<%=urlNonSSL%>cart.asp';" value="<%=LangText("GenShoppingCart","")%>" >
			</TD>
			<TD nowrap>
				<input type="submit" name="Submit" value="<%=LangText("GenSubmit","")%>">
			</TD>
		</TR>
		<TR> 
			<TD colspan=2>&nbsp;</TD>
		</TR>
		
<%		'Check for valid shipping rates
		if validRatesFound then %>
			<TR>
				<TD colspan="2" valign=middle class="CPpageHead">
					<b><%=LangText("GenResult","")%></b>
				</TD>
			</TR>
			<TR><TD colspan=2><img src="../../UserMods/misc_cleardot.gif" height=4 width=1></TD></TR>
		
<%			'Display shipping rates
			for f = 0 to Ubound(shipArray) 
				if len(trim(shipArray(f,0))) > 0 then %>
				<TR>
					<TD colspan=2 class="CPgenHeadings">
						&bull; <%=shipArray(f,1)%>&nbsp;&nbsp;<b><%=moneyS(Exchange(shipArray(f,0)))%></b>
					</TD>
				</TR>
<%				end if
			next
		
			'Show UPS Trademark Notice if required
			if len(trim(session(storeID & "UPSnotice")&"")) > 0 then %>
				<TR>
					<TD colspan="2"><br><br><%=session(storeID & "UPSnotice")%></TD>
				</TR>
<%			end if
			
			if len(trim(session(storeID & "FEDEXnotice")& "")) > 0 then %>
				<tr>
					<td colspan="2"> <br><br><%=session(storeID & "FEDEXnotice")%></td>
				</tr>
<%			end if		
		end if %>

		</form>
	</TABLE>

	<!-- End Outer Table Cell -->
	</td></tr></table>
	<br>
<%
end sub
%>